/*
 * SelectProjectDialog.java
 *
 * Created on 21 March 2002, 22:35
 */

package com.togethersoft.modules.p4vcs.dialogs;

import com.perforce.api.Client;
import com.togethersoft.openapi.ide.window.IdeDialogButtonGroup;
import com.togethersoft.openapi.ide.window.IdeWindowManager;
import com.togethersoft.openapi.ide.window.IdeWindowManagerAccess;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;

/** @author  Administrator */
public class SelectProjectDialog
{
   /** Creates new form SelectProjectDialog */
   public SelectProjectDialog(Object[] clientArray)
   {
      clientModel = new DefaultComboBoxModel(clientArray);
      initComponents();
   }

   /**
    * This method is called from within the constructor to initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is always regenerated by the Form Editor.
    */
   private void initComponents()
   { //GEN-BEGIN:initComponents
      IdeWindowManager idewindowmanager = IdeWindowManagerAccess.getWindowManager();
      dialog = idewindowmanager.createDialog(null);
      changeNumberPanel = new Panel();
      descriptionTextArea = new JTextArea();
      descriptionScrollPane = new JScrollPane(descriptionTextArea);
      clientComboBox = new JComboBox(clientModel);
      clientComboBox.setRenderer(new ClientRenderer());
      clientComboBox.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent evt)
             {
                clientComboBoxActionPerformed(evt);
             }
          });
      clientLabel = new JLabel();
      mainPanel = new JPanel();
      clientPanel = new JPanel();
      descriptionPanel = new JPanel();
      buttonPanel = new JPanel();
      okButton = (JButton)idewindowmanager.setupStandardButton(null, "ok");
      cancelButton = (JButton)idewindowmanager.setupStandardButton(null, "cancel");
      dialog.setTitle("Select Client Specification");
      dialog.setModal(true);
      dialog.setSize(new Dimension(550, 300));
      dialog.addWindowListener(
          new WindowAdapter()
          {
             public void windowClosing(WindowEvent evt)
             {
                closeDialog(evt);
             }
          });
      mainPanel.setLayout(new BorderLayout());
      clientPanel.setLayout(new GridLayout(1, 3));
      clientPanel.add(clientLabel);
      clientPanel.add(clientComboBox);
      clientPanel.add(changeNumberPanel);
      mainPanel.add(clientPanel, BorderLayout.NORTH);
      descriptionPanel.setLayout(new GridLayout(1, 1));
      descriptionPanel.add(descriptionScrollPane);
      mainPanel.add(descriptionPanel, BorderLayout.CENTER);
      IdeDialogButtonGroup idedialogbuttongroup = IdeWindowManagerAccess.getWindowManager().createButtonGroup();
      idedialogbuttongroup.add(okButton);
      idedialogbuttongroup.add(cancelButton);
      buttonPanel.add(okButton);
      cancelButton.setText("Cancel");
      buttonPanel.add(cancelButton);
      mainPanel.add(buttonPanel, BorderLayout.SOUTH);
      dialog.getContentPane().add(mainPanel, BorderLayout.CENTER);
      descriptionScrollPane.setPreferredSize(new Dimension(500, 160));
      descriptionScrollPane.setMinimumSize(new Dimension(500, 160));
      descriptionScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      dialog.pack();
      clientLabel.setText("Client Specification");
      clientLabel.setToolTipText("Client Specification");
      clientLabel.setHorizontalAlignment(SwingConstants.CENTER);
      okButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { okButtonActionPerformed(e); }
          });
      cancelButton.addActionListener(
          new ActionListener()
          {
             public void actionPerformed(ActionEvent e) { cancelButtonActionPerformed(e); }
          });
      descriptionTextArea.setSize(new Dimension(500, 275));
      descriptionTextArea.setEditable(false);
      Client client = (Client)clientComboBox.getSelectedItem();
      StringBuffer description = new StringBuffer();
      description.append("Hostname:\t");
      description.append(client.getHost());
      description.append("\n");
      description.append("Root:\t");
      description.append(client.getRoot());
      description.append("\n");
      description.append("Options:\t");
      description.append(client.getOptions());
      descriptionTextArea.setText(description.toString());
      descriptionTextArea.setCaretPosition(1);
      clientName = client.getName();
   } //GEN-END:initComponents

   public void showDialog()
   {
      Dimension dimension = dialog.getContentPane().getSize();
      Dimension dimension1 = Toolkit.getDefaultToolkit().getScreenSize();
      dialog.setLocation((dimension1.width - dimension.width) / 2, (dimension1.height - dimension.height) / 2);
      oK = false;
      dialog.setVisible(true);
   }

   /** Closes the dialog */
   private void closeDialog(WindowEvent evt)
   { //GEN-FIRST:event_closeDialog
      dialog.setVisible(false);
      dialog.dispose();
   } //GEN-LAST:event_closeDialog

   private void clientComboBoxActionPerformed(ActionEvent evt)
   { //GEN-FIRST:event_changeListComboBoxActionPerformed
      Client client = (Client)clientComboBox.getSelectedItem();
      StringBuffer description = new StringBuffer();
      description.append("Hostname:\t");
      description.append(client.getHost());
      description.append("\n");
      description.append("Root:\t");
      description.append(client.getRoot());
      description.append("\n");
      description.append("Options:\t");
      description.append(client.getOptions());
      descriptionTextArea.setText(description.toString());
      descriptionTextArea.setCaretPosition(1);
      clientName = client.getName();
   }

   public void okButtonActionPerformed(ActionEvent e)
   {
      oK = true;
      dialog.setVisible(false);
      dialog.dispose();
   }

   public void cancelButtonActionPerformed(ActionEvent e)
   {
      oK = false;
      dialog.setVisible(false);
      dialog.dispose();
   }

   public boolean isOK()
   {
      return oK;
   }

   public String getClientName()
   {
      return clientName;
   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   public JDialog dialog;
   private JPanel mainPanel;
   private JPanel clientPanel;
   private JPanel descriptionPanel;
   private JPanel buttonPanel;
   private JButton okButton;
   private JButton cancelButton;
   private JLabel clientLabel;
   private JComboBox clientComboBox;
   private JScrollPane descriptionScrollPane;
   private JTextArea descriptionTextArea;
   private Panel changeNumberPanel;
   private ComboBoxModel clientModel;
   // End of variables declaration//GEN-END:variables
   private boolean oK = true;
   private String clientName;
}
